/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################





//BOOST_CLASS_TRACKING(ai::assoc_net_1_with_echolines, boost::serialization::track_never)




#define USE_NET					1


#if 0
	#define STATUSES			\
								\
		TURN_LEFT,				\
		STRAIGHT,				\
		TURN_RIGHT,				\
		STOP,					\
		BACKWARDS_STRAIGHT,		\
		WAIT_FOR_START,			\
		BUTTONCLICK_PAUSE,		\
		MANUAL_PAUSE
#endif


enum statuses
{
	//STATUSES
	STATUS_TABLE_BEGINNING = -1,
	
	TURN_LEFT,				
	STRAIGHT,				
	TURN_RIGHT,				
	STOP,					
	//BACKWARDS_STRAIGHT,		
	WAIT_FOR_START,
	
	ACTION_COMPLETE_PAUSE,
	
	BUTTONCLICK_PAUSE,
	BUTTONCLICK_PAUSE__NET_LOADED,
	BUTTONCLICK_PAUSE__NET_SAVED,
	
	MANUAL_PAUSE,
	
	STATUS_TABLE_END	
};


enum motors
{
	LEFT_MOTOR, 
	RIGHT_MOTOR
};

enum modes
{
	MODE_PREDICT,
	MODE_LEARN
};

///########################################################################
///
///########################################################################

extern mySemaphore* net_exist_Semaphore;
extern mySemaphore* step_completion_semaphore;

//extern ai::assoc_net_1_with_echolines					echolines_net_instance;
tasandid_server_net_type							*net = NULL; //echolines_net_instance;

extern mySemaphore *global_executeSemaphore;
extern bool exitflag;
extern int exit_progress;

extern long *_crtBreakAlloc_ptr;



curses::WINDOW *win = NULL;
__declspec(thread) char cbuf[256];



myLog													m_log("tasandid_controller.data");

int																	MAX_NUM_DISPLAY_CHARTS = 1;
int																	MAX_NUM_DISPLAY_COLS = 3;
const long															max_line_i_in_chart = 16;


#if USE_OPERANT_NET	
	const int fixedcols = 4;
#else
	const int fixedcols = 2;
#endif


///########################################################################


bool do_beep = false;


DWORD WINAPI beeper_thread_worker(LPVOID UNUSED(threadInfo))
{

#pragma warning(disable : 4127)	
	while (!exitflag)
#pragma warning(default : 4127)	
	{
	
		if (do_beep)
		{
			do_beep = false;			///lets reset it before the beep
			

			Beep(
			  1000,	///DWORD dwFreq,
			  200	///DWORD dwDuration	in ms
			);
			
		}
		
		
		Sleep(10);
	}
	
	
	
	exit_progress--;
	return 1;		

}

///########################################################################

DWORD WINAPI debug_table_thread_worker(LPVOID UNUSED(threadInfo))
{

	using namespace curses;


#if _DEBUG

	long *local_crtBreakAlloc_ptr = &_crtBreakAlloc;
	*local_crtBreakAlloc_ptr = *_crtBreakAlloc_ptr;


	_CrtSetDbgFlag (_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	_CrtSetBreakAlloc(*_crtBreakAlloc_ptr);

#endif


	static int x_scroll = 0;
	static int y_scroll = 0;
	static int cycles = 0;


#pragma warning(disable : 4127)	
	while (!exitflag)
#pragma warning(default : 4127)	
	{
		bool key_pressed = false;
		int key;
		static int key_prev = ERR;	
		
		
		
		
		net_exist_Semaphore->lock();
		
		if (win != NULL)	
		{
			///nocbreak();
			noecho();
			keypad(win, true);	   ///If enabled (bf is TRUE), the user can press a function key (such as the left arrow key) and getch() will return a single value that represents the KEY_LEFT function key
			///raw();
		
			nodelay(win, true);	  ///In delay mode, the program would hang until the system passes text through to the program.
			key = wgetch(win);
		}
		else
		{
			key = ERR;
		}
		
		net_exist_Semaphore->unlock();
		
		
		
		
		if (key_prev != key)
		{
			key_pressed = true;
			
			switch(key)
			{
			
				case KEY_LEFT:
					x_scroll--;
					break;
					
				case KEY_RIGHT:
					x_scroll++;
					break;
					
				case KEY_UP:
					y_scroll--;	
					break;
					
				case KEY_DOWN:
					y_scroll++;
					break;
					
					
				case KEY_PPAGE:
					y_scroll -= MAX_NUM_DISPLAY_CHARTS;
					break;
					
				case KEY_NPAGE:
					y_scroll += MAX_NUM_DISPLAY_CHARTS;
					break;
					
				case KEY_HOME:
					x_scroll -= MAX_NUM_DISPLAY_COLS - fixedcols;
					break;
					
				case KEY_END:
					x_scroll += MAX_NUM_DISPLAY_COLS - fixedcols;
					break;
					
					
				default:
					key_pressed = false;
					break;		
			}
		}
		
		key_prev = key;
		
		
		
		
		cycles++;														
		
		if ((cycles == 10) || key_pressed)	  ///lets update screen every 300 ms
		{	
			cycles = 0;
			
		
			//global_executeSemaphore->lock();
			net_exist_Semaphore->lock();
			
			if (controller_ptr == NULL)				//lets start controller right now
			{
				//start_controller(); 
				//controller_ptr->init_net(TRUE); 				
			}

			//global_executeSemaphore->unlock();	
			
			
			if ((controller_ptr != NULL) && (net != NULL))				//lets start controller right now
			{		
				controller_ptr->output_innercells_to_console(&x_scroll, &y_scroll);	
			}
			
			
			net_exist_Semaphore->unlock();
		}
		
		
		
		Sleep(30);
	}
	
	
	
	exit_progress--;
	return 1;
};

///########################################################################


extern myThread *debug_table_thread;
extern myThread *beeper_thread;

void __cdecl debug_table_thread_init()
{
	if (net_exist_Semaphore == NULL)
	{
		std::string name1 = "net_exist_semaphore";
		net_exist_Semaphore = new mySemaphore(name1, 1, 1, CREATE, TRUE);
		
		std::string name2 = "step_completion_semaphore";
		step_completion_semaphore = new mySemaphore(name2, 1, 1, CREATE, TRUE);
		
		
		
		if (debug_table_thread != NULL)
			delete debug_table_thread;
		

		if (beeper_thread != NULL)
			delete beeper_thread;
		


		
		///myThreadArgument* debug_table_thread_Argument = new myThreadArgument(NULL, my_coutSemaphore, my_execSemaphore, &controller_ptr, name3);
		debug_table_thread = new myThread(debug_table_thread_worker, NULL);						///will wait for new connections
		debug_table_thread->execute();
		exit_progress++;
		
		
		
		do_beep = false;
		
		beeper_thread = new myThread(beeper_thread_worker, NULL);						///will wait for new connections
		beeper_thread->execute();
		exit_progress++;
		
	}				
};



