/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################



#ifndef DEFINITIONS_H						 ///TODO: merge with macros.h
#define DEFINITIONS_H







#include "datastructures/chart_datastructures.h"				//must be included before custom definitions take place!















#ifndef DEFINITIONS_H2
#define DEFINITIONS_H2


//#######################################################################
//
//#######################################################################


/// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif



//#ifndef size_t
typedef _W64 unsigned int		size_t;
//#endif



namespace definitions
{



//#define ssize_t				_W64 signed int
//#ifndef ssize_t_DEFINED
//#define ssize_t_DEFINED
//__if_not_exist (ssize_t) 
//{
typedef _W64 signed int			ssize_t;	
//}
//#endif

//#######################################################################
//
//#######################################################################


//#ifdef		NET_
//#define Y																			//virtual
//#define Y_BACKUP_DEF																//virtual



#define O																			operator
///typedef operator O;
//#define A																		    float
///#define V																		    void
typedef void			V;
#define C																		    const
///typedef const C;
#define R																		    return
///#define B																		    bool
typedef bool			B;
#define F																		    false
//#define T																		    true
///#define I																		    int
typedef int				I;
///#define U																			unsigned int
//typedef unsigned int	U;

///#define S																			ssize_t
//#ifndef S
typedef ssize_t			S;
//#endif

//#define SSIZE_T_DEFINED
//#define SS																		ssize_t










#ifdef DEFINITIONS_CPP


#else

extern long NAN_C;
extern long NNAN_C;

extern long SNAN_C;
extern long NSNAN_C;

extern long INF_C;
extern long NINF_C;

extern bool enable_break_global;


extern size_t NULL_C;


#endif



#define NAN																		    (*(const float *)(&NAN_C))			//quiet NaN
#define NNAN																		(*(const float *)(&NNAN_C))			//quiet -NaN

#define SNAN																		(*(const float *)(&SNAN_C))			//signalling NaN
#define NSNAN																		(*(const float *)(&NSNAN_C))			//signalling -NaN

#define INF																		    (*(const float *)(&INF_C))			//Infinity
#define NINF																		(*(const float *)(&NINF_C))			//-Infinity


#define NULLVAL																		(*(const size_t *)(&NULL_C))


//#######################################################################



	   
	
//#######################################################################



   
#if _DEBUG

	#define DEBUG_SEMAPHORE_LOCK														debug_semaphore_lock();
	#define DEBUG_SEMAPHORE_UNLOCK														debug_semaphore_unlock();
	
#else
	
	#define DEBUG_SEMAPHORE_LOCK														debug_semaphore_lock();
	#define DEBUG_SEMAPHORE_UNLOCK														debug_semaphore_unlock();
		
#endif






//assert(0);
//#define INR																		    #pragma warning(disable:4716)
//#define INRE																		#pragma warning(default:4716)

//#######################################################################
//
//#######################################################################


}	//namespace definitions


#endif			//#ifndef DEFINITIONS_H2




#include "datastructures/datatypes.h"




#endif		//#ifndef DEFINITIONS_H
		   